﻿Type=Class
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
  Public ABMComp As ABMCustomComponent
  Private data As Map
End Sub
 
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	data.Initialize
	data.Put("name11","")
	data.Put("name12","")
	For n1=1 To 4
		data.Put("light1" & n1,False)
        data.put("second1" & n1, "0")
        data.Put("percent1" & n1,"0")
	Next
	'
	InternalPage.AddExtraCSSFile("custom/"&ID&".css")
	WritetoCSS(ID)	
	'InternalPage.AddExtraJavaScriptFile("custom/"&ID&".js")
	'WritetoJS(ID)
  	ABMComp.Initialize("ABMComp", Me, InternalPage, ID)
End Sub

public Sub AddExtraJavaScriptFile(page As ABMPage)
	page.AddExtraJavaScriptFile("custom/archer.min.js")	
End Sub
 
private Sub ABMComp_Build(internalID As String) As String
  Return $"
  <script type="text/javascript">
  	var lightn = [0,0,0,0];
	var lightb = [false,false,false,false];
  	var rootUrl = 'eqtcard/';
	var assetUrl = rootUrl + 'assets';
	var graphicUrl = rootUrl + 'archer.graphic.svg';
    var configUrl = rootUrl + 'archer.config.json';
    var container1;
    var graphic;
	</script>
  "$
End Sub
 
' Is useful to run some initalisation script.
private Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim script As String = $"							
		container1 = document.getElementById('${internalID}');
    	graphic = archer.create(container1);
    	graphic.document.setAssetRoot(assetUrl);
    	graphic.loadUrl(graphicUrl, configUrl);		
		
		graphic.on('ready', function () {
        	// Make graphic fit into container bounds
       		graphic.view.zoomToFit(0,false);
			//graphic.view.centerAt(-800,0, true);
			// Enable zoom / pan with mouse
        	graphic.view.enableMouse(false,false);      	
        	

        	// Set variable values
			graphic.setValue('name11','');
        	graphic.setValue('name12','');
			
        	graphic.setValue('light11', 0);
        	graphic.setValue('second11', '0');
        	graphic.setValue('percent11', '0');
			
        	graphic.setValue('light12', 0);
			graphic.setValue('second12', '11');
        	graphic.setValue('percent12', '11');
			
        	graphic.setValue('light13', 0);
			graphic.setValue('second13', '0');
			graphic.setValue('percent13', '0');
			
        	graphic.setValue('light14', 0);	        	
        	graphic.setValue('second14', '0');        	
        	graphic.setValue('percent14', '0');
			
			setInterval(function() { 
				var n1;
				for(n1=0 ; n1<=3 ; n1++)
				{
					if ( lightb[n1] ) 
					{
						lightn[n1] = lightn[n1] + 1;
						if(lightn[n1] > 10) lightn[n1] = 0;
						graphic.setValue('light1'+(n1+1), lightn[n1]);
					} 
					else 
					{
						if(lightn[n1] > 0) 
						{
							lightn[n1] = 0;
							graphic.setValue('light1'+(n1+1), lightn[n1]);
						};
					};
				};
				
			}, 150);			
    	}); "$
			
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
End Sub

public Sub Refresh
	If ABMComp.IsInitialized Then
		ABMComp.Refresh
	End If
End Sub
 
' runs when a refresh is called
private Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	Dim script As String = updateValue(InternalPage,internalID)
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
End Sub

Private Sub updateValue(InternalPage As ABMPage, internalID As String) As String
	Dim script As String = $"	
		graphic.setValue('name11','${data.Get("name11")}');
		graphic.setValue('name12','${data.Get("name12")}');
	
		lightb[0] = ${data.Get("light11")};
		graphic.setValue('second11','${data.Get("second11")}');
		graphic.setValue('percent11','${data.Get("percent11")}');
		
		lightb[1] = ${data.Get("light12")};
		graphic.setValue('second12','${data.Get("second12")}');
		graphic.setValue('percent12','${data.Get("percent12")}');
		
		lightb[2] = ${data.Get("light13")};
		graphic.setValue('second13','${data.Get("second13")}');
		graphic.setValue('percent13','${data.Get("percent13")}');
		
		lightb[3] = ${data.Get("light14")};
		graphic.setValue('second14','${data.Get("second14")}');
		graphic.setValue('percent14','${data.Get("percent14")}');
	"$	
	' InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
	Return script
End Sub
' index  1:run  2:down  3:maint  4:lack(缺料)
Sub CardValue(Index As Int,Status As Boolean,Seconds As String,Percents As String)
	If (Index>=1)And(Index<=4) Then
		data.Put("light1"&Index,Status)
		data.Put("second1"&Index,Seconds)
		data.Put("percent1"&Index,Percents)	
	End If	
End Sub
' name1:機台名  name2:製程名
Sub CardName(name1 As String,name2 As String)
		data.Put("name11",name1)
		data.Put("name12",name2)
End Sub
 
' do the stuff needed when the object is removed
private Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
 
End Sub

private Sub WritetoCSS(internalID As String) As String
	Dim s1 As String=$" #${internalID} {			
            width: 770px;
            height: 140px;
			top:0px;
			left:0px;
			margin-left: 0px;	
			margin-top: 0px;	
		}"$
		
	Dim s3 As String="www\css\custom\"&internalID&".css"
	File.WriteString(File.DirApp,s3,s1)
	Return s1
End Sub
