﻿Type=StaticCode
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public MyTheme As ABMTheme	
	Private ABM As ABMaterial 'ignore	
	Public NeedsAuthorization As Boolean = True
	'Public AppVersion As String = ""
	Public AppVersion As String = DateTime.Now
	Public AppPublishedStartURL As String = "http://www.rwblinn.de"
	Public CachedPages As Map
	Public AppName As String = "dnc-node"
	Public CacheScavengePeriodSeconds As Int = 15*60 ' 15 minutes ' 10 minutes
	Public SessionMaxInactiveIntervalSeconds As Int = 30*60 ' 30 minutes '1*60*24 ' one hour ' -1 = immortal but beware! This means the cache is NEVER emptied!
End Sub

Public Sub NavigateToPage1(ws As WebSocket, TargetUrl As String)	
	If AppVersion <> "" Then
		TargetUrl = TargetUrl & "?" & AppVersion
	End If
	If ws.Open Then
		ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))			
	End If
End Sub

Sub BuildFooter(page As ABMPage)		
	page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "") 
	page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components	
	
	page.Footer.UseTheme("footertheme")		
End Sub

Public Sub NavigateToPage(ws As WebSocket, PageId As String, TargetUrl As String)	
	If AppVersion <> "" Then
		TargetUrl = TargetUrl & "?" & AppVersion
	End If
	ABM.RemoveMeFromCache(CachedPages, PageId)
	
	If ws.Open Then
		ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))			
		ws.Flush
	End If
End Sub	

Sub Mid(Text As String, Start As Int, Length As Int) As String
   Return Text.SubString2(Start-1,Start+Length-1)
End Sub

Sub Mid2(Text As String, Start As Int) As String
   Return Text.SubString(Start-1)
End Sub

public Sub BuildImage(page As ABMPage, id As String, image As String, opacity As Double, Caption As String) As ABMImage
	Dim img As ABMImage
	img.Initialize(page, id, image,opacity)
	img.IsMaterialBoxed = True
	img.IsResponsive = True
	img.Caption = Caption
	Return img
End Sub

Sub ConnectFooter(page As ABMPage)	
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "footlbl1", "Blog: Alwaysbusy's Corner{BR}{BR}B4J by Anywhere Software{BR}Materialize CSS by students from Carnegie Mellon University",ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,1).AddComponent(lbl1)
	
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, "footlbl2", "ABMaterial Copyright @2015-2016{BR}By Alain Bailleul{BR}{BR}Email: alain.bailleul@telenet.be",ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,2).AddComponent(lbl2)	
End Sub

Sub BuildFooterFixed(page As ABMPage)	
	page.isFixedFooter= True
	' because we have a fixed footer at the bottom, we have to adjust the padding of the body in pixels
	page.PaddingBottom = 200
	
	page.Footer.AddRows(1, True, "").AddCellsOS(2,0,0,0,6,6,6, "") 
	page.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components	
	
	page.Footer.UseTheme("footertheme")	
End Sub

Sub ConnectFooterFixed(page As ABMPage)		
	Dim lbl1 As ABMLabel
	lbl1.Initialize(page, "footlbl1", "Blog: Alwaysbusy's Corner{BR}{BR}B4J by Anywhere Software{BR}Materialize CSS by students from Carnegie Mellon University",ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,1).AddComponent(lbl1)
	
	Dim lbl2 As ABMLabel
	lbl2.Initialize(page, "footlbl2", "ABMaterial Copyright @2015-2016{BR}By Alain Bailleul{BR}{BR}Email: alain.bailleul@telenet.be",ABM.SIZE_PARAGRAPH, False, "whitefc")
	page.Footer.Cell(1,2).AddComponent(lbl2)	
End Sub

' build methods for ABM objects
Sub BuildTheme(themeName As String)
	MyTheme.Initialize(themeName)
	
	' Page theme
	MyTheme.Page.BackColor = ABM.COLOR_TEAL
	MyTheme.Page.BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	
	' Header theme
	MyTheme.AddRowTheme("headertheme")
	MyTheme.Row("headertheme").BackColor = ABM.COLOR_TEAL
	MyTheme.Row("headertheme").BackColorIntensity = ABM.INTENSITY_DARKEN1	

	' Footer theme
	MyTheme.AddContainerTheme("footertheme")
	MyTheme.Container("footertheme").BackColor = ABM.COLOR_TEAL
	MyTheme.Container("footertheme").BackColorIntensity = ABM.INTENSITY_LIGHTEN2
	
	' Footer label theme
	MyTheme.AddLabelTheme("whitefc")
	MyTheme.Label("whitefc").ForeColor = ABM.COLOR_WHITE
	
	' Footer label theme
	MyTheme.AddLabelTheme("justify")
	MyTheme.Label("justify").align = ABM.TEXTALIGN_JUSTIFY
		
	' Label theme
	MyTheme.AddLabelTheme("lightblue")
	MyTheme.Label("lightblue").ForeColor = ABM.COLOR_LIGHTBLUE	
	MyTheme.Label("lightblue").ForeColorIntensity = ABM.INTENSITY_DARKEN2

	MyTheme.AddLabelTheme("bluefc")
	MyTheme.Label("bluefc").ForeColor = ABM.COLOR_BLUE

	MyTheme.AddLabelTheme("redfc")
	MyTheme.Label("redfc").ForeColor = ABM.COLOR_BLUE

	MyTheme.AddButtonTheme("buttonon")
	MyTheme.Button("buttonon").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonon").BackColor = ABM.COLOR_GREEN

	MyTheme.AddButtonTheme("buttonoff")
	MyTheme.Button("buttonoff").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonoff").BackColor = ABM.COLOR_RED
	
	MyTheme.AddToastTheme("toasttheme")
	MyTheme.Toast("toasttheme").ForeColor = ABM.COLOR_WHITE
	MyTheme.Button("buttonoff").BackColor = ABM.COLOR_BLUE
	MyTheme.Toast("toasttheme").Rounded = True
	
	MyTheme.AddSwitchTheme("switchtheme")
	MyTheme.Switch("switchtheme").SwitchOnColor = ABM.COLOR_GREEN
	MyTheme.Switch("switchtheme").SwitchOnColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").SwitchOffColor = ABM.COLOR_RED
	MyTheme.Switch("switchtheme").SwitchOffColorIntensity = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").LabelColor = ABM.COLOR_BLACK
	MyTheme.Switch("switchtheme").LabelColor = ABM.INTENSITY_DARKEN4
	MyTheme.Switch("switchtheme").LabelFontSize = "28px"
	MyTheme.Switch("switchtheme").Colorize(ABM.COLOR_TEAL)
End Sub

public Sub BuildParagraph(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim lbl As ABMLabel	
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
	Return lbl
End Sub

Sub LogOff(page As ABMPage)
	Dim Network As String = page.ws.Session.GetAttribute("authType")
	Dim Name As String = page.ws.Session.GetAttribute("authName")
	Select Case Network
		Case "local"
		
		Case ABM.SOCIALOAUTH_FACEBOOK
			' the event SignedOffSocialNetwork will be raised on the page, do the rest there
			page.SignOffSocialNetwork(Network, "", Name)		
		Case Else	
			' do whatever you have to do to log off your user			
			page.ws.Session.SetAttribute("authType", "")
			page.ws.Session.SetAttribute("authName", "")
			page.ws.Session.SetAttribute("IsAuthorized", "")				
			NavigateToPage(page.ws, page.GetPageID, "../")			
	End Select	
End Sub


#Region NavigationBar

Sub BuildNavigationBar(page As ABMPage, Title As String, logo As String, ActiveTopReturnName As String, ActiveSideReturnName As String, ActiveSideSubReturnName As String) 
	'page.SetFontStack("arial,sans-serif") ' this is the default now
	
	' old declaration:
	'page.NavigationBar.Initialize(page, "nav1", Title, ABM.TEXTALIGN_LEFT, False, True, False,True, 330, 48, logo, ABM.COLLAPSE_ACCORDION, "nav1theme")	
	
	' new declarations:
	
	' we have to make an ABMImage from our logo url
	Dim sbtopimg As ABMImage
	sbtopimg.Initialize(page, "sbtopimg", logo, 1)
	sbtopimg.SetFixedSize(236, 49)
	
	' our top component can be a more complex component than an image
	'Dim sbtopimg As ABMContainer = BuildSideBarTopComponent(page, "sbtopimg", "../images/me.jpg", "Me", "Simply the best")
	'' we have to adjust the 'logo' height
	'page.NavigationBar.SideBarLogoHeight = 245
	
	
	' behaviour as the old declaration	
	page.NavigationBar.Initialize(page, "nav1", ABM.SIDEBAR_MANUAL_HIDEMEDIUMSMALL, Title, True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "nav1theme")	
	
	' new behaviour, the sidebar is ALWAYS hidden
	' page.NavigationBar.Initialize(page, "nav1", ABM.SIDEBAR_MANUAL_ALWAYSHIDE, Title, True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "nav1theme")	
	
	' new behaviour, the sidebar is created automatically from the top items if the device size is tablet or mobile
	' note in this case, ALL AddSideBarItem(), AddSideBarSubItem(), AddSideBarDivider() and AddSideBarSubDivider() calls will be IGNORED, as the sidebar will be build dynamically from the top items!
	' page.NavigationBar.Initialize(page, "nav1", ABM.SIDEBAR_AUTO, Title, True, True, 330, 48, sbtopimg, ABM.COLLAPSE_ACCORDION, "nav1theme")	
	page.NavigationBar.TopBarDropDownConstrainWidth = False
	page.NavigationBar.ActiveTopReturnName = ActiveTopReturnName
	page.NavigationBar.ActiveSideReturnName = ActiveSideReturnName
	page.NavigationBar.ActiveSideSubReturnName = ActiveSideSubReturnName
	
	' you must add at least ONE dummy item if you want to add items to the topbar	in ConnectNaviagationBar
	page.NavigationBar.AddTopItem("DUMMY", "DUMMY", "", "", False)
	
	' you must add at least ONE dummy item if you want to add items to the sidebar	
	page.NavigationBar.AddSideBarItem("DUMMY", "DUMMY", "", "")		
	
End Sub

Sub ConnectNavigationBar(page As ABMPage)
	
	' Clear the dummies we created in BuildNavigationBar
	page.NavigationBar.Clear
	
'	Dim comp As ABMComponent = page.NavigationBar.SideBarTopComponent
'	If comp <> Null Then
'		If comp.Type = ABM.UITYPE_ABMCONTAINER Then
'			Dim topItem As ABMContainer = ABM.CastABMComponent(comp)
'			Dim subContainer As ABMContainer = topItem.Component(comp.ID & "SubItemCont")
'			Dim lbl1 As ABMLabel = subContainer.Component(comp.ID & "lbl1")
'			lbl1.Text = "I'm changed!"
'			topItem.Refresh
'		End If
'	End If
	
	' this is a special one: a full screen toggle icon.  Will be handled automatically
	' this is experimental, as it has side effects e.g. when you navigate to another page, it is switched of again
	'nb.AddTopFullScreenIcon
	
	' new behaviour: on each top item you can set if it should hide of not on a medium or small device.
	page.NavigationBar.AddTopItem("Contact", "", "mdi-action-account-circle", "", False)
	page.NavigationBar.AddTopItem("Logoff", "", "mdi-action-exit-to-app", "", False)

'   NOTE Extra Sidebar
'   Page_NavigationbarClicked() is NOT raised for an Extra sidebar!
	
'   BEGIN Extra SideBar	
'	Dim extraSideBar As ABMSideBar
'	extraSideBar.Initialize(page, "extrasidebar", 530, 48, 56, Null, ABM.COLLAPSE_ACCORDION, "nav2theme")
'	extraSideBar.AddSideBarComponent("esbHello", BuildSideBarComponent(page, "sidebarcomp", "../images2/16.jpg", "This is a sidebar component", "With an image and an editor"))
'	page.NavigationBar.AddTopItemWithSideBar("SideBar", "", "mdi-action-dashboard", "", False, extraSideBar)
'	
'	Dim extraSideBar2 As ABMSideBar
'	extraSideBar2.Initialize(page, "extrasidebar2", 330, 48,56, Null, ABM.COLLAPSE_ACCORDION, "nav3theme")
'	extraSideBar2.AddSideBarDivider("")
'	extraSideBar2.AddSideBarItem("esbHello2", "Hello Again!", "mdi-action-invert-colors")
'	
'	page.NavigationBar.AddTopItemWithSideBar("SideBar2", "", "mdi-action-dashboard", "", False, extraSideBar2)
'	
'	Dim extraSideBar3 As ABMSideBar
'	extraSideBar3.Initialize(page, "extrasidebar3", 330, 48,56, Null, ABM.COLLAPSE_ACCORDION, "nav4theme")
'	extraSideBar3.AddSideBarDivider("")
'	extraSideBar3.AddSideBarItem("esbHello3", "Hello!", "mdi-action-invert-colors")
'	
'	page.NavigationBar.AddTopItemWithSideBar("SideBar3", "", "mdi-action-dashboard", "", False, extraSideBar3)
'    END Extra Sidebar
	
	' Example topbar items with dropdown
'	page.NavigationBar.AddTopItem("About", "About", "", "", True)
'	page.NavigationBar.AddTopItem("Themes", "Themes", "", "", True)
'	page.NavigationBar.AddTopSubItem("Themes", "Lightblue", "Very Light Blue", "", "")
'	page.NavigationBar.AddTopSubItem("Themes", "Orange", "Orange", "", "")
'	page.NavigationBar.AddTopSubItem("Themes", "Black", "Black", "", "")
'	page.NavigationBar.AddTopItem("Layouts", "Layouts", "", "",True)
	
	' example of adding a component (container) to a side bar menu		
	'page.NavigationBar.AddSideBarComponent("TestComp1", BuildSideBarComponent(page, "tcS1", "../images/mom.jpg", "Mom", "The loving one"), "")	
	'page.NavigationBar.AddSideBarComponent("TestComp2", BuildSideBarComponent(page, "tcS2", "../images/dad.jpg", "Dad", "The strong one"), "")	
	'page.NavigationBar.AddSideBarComponent("TestComp3", BuildSideBarComponent(page, "tcS3", "../images/brother.jpg", "Brother", "My best friend"), "")
	'page.NavigationBar.AddSideBarComponent("TestComp4", BuildSideBarComponent(page, "tcS4", "../images/sister.jpg", "Sister", "The annoying one"), "")
	page.NavigationBar.AddSideBarItem("Equipment","Equipment", "mdi-communication-business", "")
	page.NavigationBar.AddSideBarDivider("")
	page.NavigationBar.AddSideBarSubItem("Equipment","Add","Add", "mdi-content-add-box", "../NewEqPage/index.html")
	
	page.NavigationBar.AddSideBarDivider("")
	page.NavigationBar.AddSideBarItem("Node", "Node", "mdi-action-dashboard", "")
	page.NavigationBar.AddSideBarDivider("")
	page.NavigationBar.AddSideBarSubItem("Node","Add","Add", "mdi-content-add-box", "../NewNdPage/index.html")
	
	'page.NavigationBar.AddSideBarItem("Signal","Signal", "mdi-action-extension", "../SignalPage/index.html")
	'page.NavigationBar.AddSideBarDivider("")
	page.NavigationBar.AddSideBarItem("History","History", "mdi-action-history", "../HistoryPage/index.html")
	page.NavigationBar.AddSideBarDivider("")
	page.NavigationBar.AddSideBarItem("About", "About", "mdi-content-flag", "../AboutPage/index.html")
	page.NavigationBar.AddSideBarDivider("")
	
	page.NavigationBar.Refresh ' IMPORTANT
End Sub

public Sub BuildParagraphBQ(page As ABMPage, id As String, Text As String) As ABMLabel
	Dim lbl As ABMLabel	
	lbl.Initialize(page, id, Text , ABM.SIZE_PARAGRAPH, False, "")
	lbl.IsBlockQuote = True
	Return lbl
End Sub



#End region