﻿Type=StaticCode
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private ABM As ABMaterial 'ignore		
	Private page As ABMPage
End Sub

Sub BuildContactModalSheet(Parent As ABMPage) As ABMModalSheet
	page = Parent
	Dim myModal As ABMModalSheet
	myModal.Initialize(page, "myModal", False, False, "")
	myModal.Content.UseTheme("modalcontent")
	myModal.Footer.UseTheme("modalfooter")
	myModal.IsDismissible = False
	
	' create the grid for the content
	myModal.Content.AddRows(1,True, "").AddCells12(1,"")
	myModal.Content.AddRows(2,True, "").AddCellsOS(2,0,0,0,6,6,6,"") 
	myModal.Content.AddRows(5,True, "").AddCells12(1,"")
	myModal.Content.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' add paragraph	
	myModal.Content.Cell(1,1).AddComponent(ABMShared.BuildParagraph(page,"par1","Enter your info so we can contact you later") )
	
	' create the input fields for the content
	Dim inp1 As ABMInput
	inp1.Initialize(page, "inp1", ABM.INPUT_TEXT, "Street", False, "")
	inp1.PlaceHolderText = "Streetname"
	myModal.Content.Cell(2,1).AddComponent(inp1)
	
	Dim inp2 As ABMInput
	inp2.Initialize(page, "inp2", ABM.INPUT_TEXT, "Number", False, "")
	myModal.Content.Cell(2,2).AddComponent(inp2)
	
	Dim inp3 As ABMInput
	inp3.Initialize(page, "inp3", ABM.INPUT_TEXT, "Postal Number", False, "")
	myModal.Content.Cell(3,1).AddComponent(inp3)
	
	Dim inp4 As ABMInput
	inp4.Initialize(page, "inp4", ABM.INPUT_TEXT, "City", False, "")
	myModal.Content.Cell(3,2).AddComponent(inp4)
	
	Dim inp5 As ABMInput
	inp5.Initialize(page, "inp5", ABM.INPUT_TEXT, "Country", False, "")
	myModal.Content.Cell(4,1).AddComponent(inp5)
	
	Dim inp6 As ABMInput
	inp6.Initialize(page, "inp6", ABM.INPUT_TEXT, "Location", False, "")
	myModal.Content.Cell(5,1).AddComponent(inp6)
	
	' add a editor on the row
	Dim editor As ABMEditor
	editor.Initialize(page, "editor", True, True, "editor")
	myModal.Content.Cell(6,1).AddComponent(editor)
	
	'	Dim fileinput As ABMFileInput
'    fileinput.Initialize(page,"fileinput","upload","select",False,"","")
'    myModal.Content.Cell(6,1).AddComponent(fileinput)	
	
	
	' create the grid for the footer
	' we add a row without the default 20px padding so we need to use AddRowsM().  If we do not use this method, a scrollbar will appear to the sheet.
	myModal.Footer.AddRowsM(1,True,0,0, "").AddCellsOS(1,6,6,6,3,3,3,"").AddCellsOS(1,0,0,0,3,3,3, "")
	myModal.Footer.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' create the buttons for the footer
	Dim msbtn1 As ABMButton
	msbtn1.InitializeFlat(page, "msbtn1", "", "", "OK", "transparent")
	myModal.Footer.Cell(1,1).AddComponent(msbtn1)
	
	Dim msbtn2 As ABMButton
	msbtn2.InitializeFlat(page, "msbtn2", "", "", "CANCEL", "transparent")
	myModal.Footer.Cell(1,2).AddComponent(msbtn2)
	
	Return myModal
End Sub

Sub ShowModal 
	Dim myModal As ABMModalSheet = page.ModalSheet("myModal")
	
	Dim inp1 As ABMInput = myModal.Content.Component("Inp1")
	inp1.Text = ""
	Dim inp2 As ABMInput = myModal.Content.Component("Inp2")
	inp2.Text = ""
	Dim inp3 As ABMInput = myModal.Content.Component("Inp3")
	inp3.Text = ""
	Dim inp4 As ABMInput = myModal.Content.Component("Inp4")
	inp4.Text = ""
	Dim inp5 As ABMInput = myModal.Content.Component("Inp5")
	inp5.Text = ""
	Dim inp6 As ABMInput = myModal.Content.Component("Inp6")
	inp6.Text = ""
	
	page.ShowModalSheet("myModal")
End Sub

