﻿Type=StaticCode
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private VERSION As Double = 1.0
	Private wsh As WebSocketHandler
	Private pingTimer As Timer
	Private lastServerPong As Long
	Private ReconnectTimer As Timer
	Private OrderN As Int=0
End Sub

Public Sub Create
	pingTimer.Initialize("pingTimer", 3000)
	ReconnectTimer.Initialize("ReconnectTimer", 3000)
	Connect
End Sub


Private Sub Connect
	Dim wsh As WebSocketHandler
	wsh.Initialize(Me, "wsh")
	wsh.Connect(db.serverLink)
End Sub

Public Sub Close
	If wsh.ws.Connected Then
		wsh.Close
	End If
End Sub

Sub wsh_NewMessage(Params As List)
	Dim messages As List
	messages.Initialize
	Dim ids As List
	ids.Initialize
	For i = 0 To Params.Size - 1 Step 2
		
	Next
	
	Dim mm As Map
	mm.Initialize
	mm.Put("ids", ids)
	wsh.SendEventToServer("Device_MessageDelivered", mm)
End Sub

Sub wsh_Connected
	Log("WebSocket Connected")
	pingTimer.Enabled = True
	lastServerPong = DateTime.Now
End Sub

Sub wsh_Closed (Reason As String)
	Log("WebSocket Closed: " & Reason)
	'	
	pingTimer.Enabled = False
	ReconnectTimer.Enabled = True
End Sub

Sub ReconnectTimer_Tick
	If wsh.ws.Connected = False Then
		Connect
	End If
	ReconnectTimer.Enabled = False
End Sub

Sub PingTimer_Tick
	'Log("PingTimer_Tick: " & wsh.ws.Connected & ", " & lastServerPong & ", "  & (lastServerPong + 30 * DateTime.TicksPerSecond < DateTime.Now))
	If wsh.ws.Connected = False Then Return
	
	If lastServerPong + 30 * DateTime.TicksPerSecond < DateTime.Now Then
		'Log("Closing connection after 30 seconds of no response")
		wsh.Close
	Else
		Log("ping : " & OrderN)
		Dim m As Map
		m.Initialize
		m.Put("ordernumber",OrderN)
		wsh.SendEventToServer("Device_Ping", m)
	End If
End Sub

Sub wsh_Pong(Params As List)
	If Params<>Null Then
		Dim mp As Map=Params.Get(0)
		Dim dt As Long=mp.Get("datetime")
		Dim orderN1 As Int = mp.Get("ordernumber")
		Log("pong : "& orderN1)
		If orderN1=OrderN Then
			OrderN=OrderN+1
			If OrderN	> 9999 Then OrderN=0
		End If
	End If
End Sub
' dnc-node連結上dnc-serv時,dnc-serv回饋ServerReady
Sub wsh_ServerReady(Params As List)	
	If Params<>Null Then		
		Dim data As Map=Params.Get(0)
		Dim dt As Long=data.Get("datetime")
		Log("ServerReady:" & DateTime.Date(dt) & " " & DateTime.time(dt))
		'
		Dim m As Map
		m.Initialize
		m.Put("id","001")
		m.Put("version", VERSION)
		wsh.SendEventToServer("Device_list", m)
	End If
End Sub