﻿Type=Class
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
  Public ABMComp As ABMCustomComponent
  Private data As Map
  Private datascript As String=""
End Sub
 
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	data.Initialize	
	'
	InternalPage.AddExtraCSSFile("custom/ebc"&ID&".css")
	WritetoCSS(ID)	
	'InternalPage.AddExtraJavaScriptFile("custom/"&ID&".js")
	'WritetoJS(ID)
  	ABMComp.Initialize("ABMComp", Me, InternalPage, ID)
End Sub

public Sub AddExtraJavaScriptFile(page As ABMPage)
	' page.AddExtraJavaScriptFile("custom/moment.js")
	'page.AddExtraJavaScriptFile("custom/jqplot/jquery.min.js")
	page.AddExtraJavaScriptFile("custom/jqplot/jquery.jqplot.min.js")	
	
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.cursor.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.json2.js")
	'page.AddExtraCSSFile("custom/jqplot/jquery.jqplot.css")	
	
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.dateAxisRenderer.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.highlighter.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.canvasTextRenderer.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.canvasAxisTickRenderer.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.categoryAxisRenderer.js")
	page.AddExtraJavaScriptFile("custom/jqplot/plugins/jqplot.barRenderer.js")
	page.AddExtraCSSFile("custom/jqplot/jquery.jqplot.min.css")
End Sub
 
private Sub ABMComp_Build(internalID As String) As String
  Return $"
  	<script>
	var prec = [ 52.3, 56.1,117.5,124.5,137.8,167.7,153.5,168.2,10000,197.8, 92.5, 51.0,200,400 ];
	var temp = [  100,  65,  94, 146, 189, 221, 258, 27.4, 238, 18.5, 13.3,  8.7,5,2 ];
	var temp1 = [  20,  11,  20, 24, 18, 22, 58, 27, 23.8, 18.5, 133,  8.7,5,2 ];
	var tick = [  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24];	
	var options={};
	var plot2;
	</script>
  	<div id = 'ls${internalID}'></div>"$
End Sub

public Sub ChartData(xbar As List,ybar As List,y1bar As List)  As String
	Dim n1 As Int
	Dim s1 As String=""	
	If xbar.IsInitialized Then
		If xbar.Size>0 Then
			s1="prec = [" & xbar.Get(0)
			For n1=1 To xbar.Size-1
				s1=s1 & ","&xbar.Get(n1)
			Next
			s1=s1 & "];" & CRLF
		End If
	End If
	Dim s2 As String=""	
	If ybar.IsInitialized Then
		If ybar.Size>0 Then
			s2="temp = [" & ybar.Get(0)
			For n1=1 To ybar.Size-1
				s2=s2 & "," & ybar.Get(n1)
			Next
			s2 = s2 & "];" & CRLF
		End If
	End If
	Dim s3 As String=""
	If y1bar.IsInitialized Then
		If y1bar.Size>0 Then
			s3 = "temp1 = [" & y1bar.Get(0)
			For n1=1 To y1bar.Size-1
				s3=s3 & "," & y1bar.Get(n1)
			Next
			s3 = s3 & "];" & CRLF
		End If
	End If
	datascript = s1&s2&s3
	Return datascript
End Sub

public Sub Refresh
	If ABMComp.IsInitialized Then
		ABMComp.Refresh
	End If
End Sub
 
' Is useful to run some initalisation script.
private Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	Dim script As String = $"
	options = {      
		cursor:{
			show: true,
			zoom:true, 
			showTooltip:true
		},				
		stackSeries: true,
		seriesDefaults : {
			renderer: $.jqplot.BarRenderer,
			rendererOptions : {
				barWidth: 18
			}
		},
		series:[
			{
				yaxis:'yaxis'	
			},
			{
				yaxis:'yaxis'																
			},
			{
				yaxis:'y2axis',
				disableStack : true,
				renderer: $.jqplot.LineRenderer										
			}
		],		
		axesDefaults: {
			tickRenderer: jQuery.jqplot.CanvasAxisTickRenderer,
			tickOptions: {
				angle: 0,
				fontSize: '10pt'						
			}
		},
		axes: {
			xaxis: {
				renderer: $.jqplot.CategoryAxisRenderer,						
				tickOptions: {
					angle: 40,
					fontSize: '10pt',
					formatter: function(format, value) { return '00:' + value; }						
				},
				ticks: tick											
			},
			yaxis: {
				tickOptions: { formatString: "%'d" },
				min: 0,						
				tickInterval: 90,
				numberTicks: 10,
				rendererOptions: { forceTickAt0: true }
			},
			y2axis: {
				tickOptions: { formatString: "%'d" },
				min: 0,						
				numberTicks: 10,
				rendererOptions: { forceTickAt0: true }
			}
		},				
		highlighter: {
			show: true,		
			fontSize: '18pt',					
			sizeAdjust: 24 
		},
		cursor: {
			show: true,					
			tooltipLocation:''
		}
   	};  
	plot2 = $.jqplot('ls${internalID}', [temp,temp1,prec], options);"$			
	InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
End Sub
 
' runs when a refresh is called
private Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	If datascript<>"" Then
		Dim s1 As String=$"
		${datascript};		
		if (plot2) {
     		plot2.destroy();
		}
		plot2 = $.jqplot('ls${internalID}', [temp,temp1,prec], options);"$
		InternalPage.ws.Eval(s1, Array As Object(ABMComp.ID))
	End If
End Sub

Private Sub updateValue(InternalPage As ABMPage, internalID As String) As String
	Dim script As String = $"
	plot2.redraw;"$	
	' InternalPage.ws.Eval(script, Array As Object(ABMComp.ID))
	Return script
End Sub
' do the stuff needed when the object is removed
private Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
 
End Sub

private Sub WritetoCSS(internalID As String) As String
	Dim s1 As String=$"	#${internalID} {				
			top:0px;					
			left:0px;
            width: 770px;
            height: 480px;	
			background: #FFFFFF;
			overflow:auto;
        }
		#ls${internalID} {	
			position: relative;			
			top:0px;					
			left:0px;
            width: 770x;
            height: 100%;	
		}"$
		
	Dim s3 As String="www\css\custom\ebc"&internalID&".css"
	File.WriteString(File.DirApp,s3,s1)
	
	Return s1
End Sub
