﻿Type=StaticCode
Version=4.98
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Process_Globals
	Private beFirst As Boolean
	Private kvs As KeyValueStore	
	'	
	Dim wsnode As wiseNode
	Private Parent As Object
	Private Event As String
	Private timer1 As Timer	
	'
	Private flown As Map 		' 製程名稱
	Dim dncser As Map
	Dim 	flows As Map 			' 製程明細
	Dim 	remotes As List		' 遠端IO	
	Dim	equips As Map			' 機台
	Dim signals As Map			' 遠端IO各接腳信號值
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(owner As Object,EventName As String)
	Parent = owner
	Event = EventName
	timer1.Initialize("timer1_tick",100)
	timer1.Enabled=False
	wsnode.Initialize(Me,"wsnode")
	
	kvs.Initialize(File.DirApp, "dnc-node.kvs")	
	If loadparameter>0 Then
					
	End If
End Sub

Public Sub start
	wsnode.startdc(signals)
	timer1.Enabled=True
End Sub

Public Sub Stop
	wsnode.stopdc
	timer1.Enabled=False
End Sub

private Sub ScanRemotes As Int
	
End Sub

Sub timer1_tick
	ScanRemotes
End Sub

Sub ServerLink As String
	Return dncser.GetDefault("link","")
End Sub

public Sub loadparameter As Int
	If Not(File.Exists(File.DirApp,"dnc-node.json")	) Then
		Return -1
	End If
	Dim json As String=File.ReadString(File.DirApp,"dnc-node.json")
	If json="" Then
		Return -2
	End If
	' 讀取 json 設定檔		
	Dim parser As JSONParser	
	parser.Initialize(json)
	Dim root As Map = parser.NextObject
	Dim s1,s2 As String
	Dim count As Int
	' 讀取主機資訊
	If Not(dncser.IsInitialized) Then dncser.Initialize
	dncser.Clear
	dncser.Put("link","")
	If root.ContainsKey("server") Then
		dncser = root.get("server")		
		s1=dncser.GetDefault("enable","false")
		If s1.ToUpperCase = "TRUE" Then
			s1=dncser.GetDefault("ip","")
			s2=dncser.GetDefault("port","")
			If (s1<>"")And(s2<>"") Then dncser.Put("link","ws://" & s1 & ":" & s2 & "/node_ws"	)
	 	End If
	End If
	' 讀取製程明細
	If Not(flown.IsInitialized) Then 	flown.Initialize
	flown.Clear
	If root.ContainsKey("flow") Then
		Dim node As Map = root.Get("flow")
		count = node.size
		If count>0 Then
			For n1=1 To count
				s1 = n1
				Dim mp1 As Map=node.Get(s1) ' 1,2,3
				flown.Put(s1,mp1)
			Next
		End If
	End If
	' 讀取 remote-io及信號設定
'	"1": {
'			"ip":192.168.1.1,
'			"model":WISE4060,
'			"auth":"root:00000000",
'			"signal": {							
'				"1":{
'					"used":True,
'					"pin":DI0,
'					"alias":DI01
'				},
'				"2": {
'					"used":True,
'					"pin":DI1,
'					"alias":DI02
'				},
'				"3": {
'					"used":True,
'					"pin":DI2,
'					"alias":DI03
'				},
'				"4": {
'					"used":True,
'					"pin":DI3,
'					"alias":DI04
'				}
'			}
'		},
	If Not(remotes.IsInitialized) Then remotes.Initialize
	remotes.Clear
	If Not(signals.IsInitialized) Then signals.Initialize
	signals.Clear
	If root.ContainsKey("node") Then
		Dim node As Map = root.Get("node")
		If node.size > 0 Then ' 有設定node的內容
			For n1=1 To node.size ' 1,2,3,4,....
				s1 = n1
				Dim mp  As Map=node.Get(s1) ' 讀取各別模組map
				If mp.Size>0 Then
					If mp.ContainsKey("ip") Then						
						remotes.Add(mp)
						'
						Dim ip As String=mp.Get("ip")
						Dim signal1 As Map=mp.Get("signal")
						Dim count1 As Int=signal1.size
						If count1>0 Then
							Dim mp1 As Map
							mp1.Initialize
							mp1.Put("model",mp.GetDefault("model",""))
							mp1.Put("auth",mp.Get("auth"))
							For n2=1 To count1
								s1 = n2
								Dim mp2 As Map = signal1.Get(s1) ' 讀取各別信號腳map 1,2,3,4,,,,,
								If mp2.Size>=3 Then
									Dim pn1 As String=mp2.Get("pin") ' 腳位
									mp2.Put("value",0)
									' "DI3": {
									' 	"used":True,
									' 	"pin":DI3,
									' 	"alias":DI04,
									'	"value":
									'}
									mp1.put(pn1,mp2)
								End If
							Next	
							signals.Put(ip,mp1) ' 						
						End If
					End If
				End If
			Next
		End If
	End If
	' 讀取各別機台設定
	If Not(equips.IsInitialized) Then equips.Initialize
	equips.Clear
	If root.ContainsKey("equipment") Then
		Dim node As Map = root.Get("equipment")
		count=node.size
		' 讀取所有機台名稱
		If count>0 Then	
			Dim mn As Int=0		
			For n1=1 To count
				s1 = n1 ' 1,2,3,4
				Dim mp1 As Map = node.Get(s1) ' 1,2,3,4,,,,
				If mp1.size>0 Then
					equips.Put(mp1.Get("id"),mp1)
					mn=mn+1
					Log("adding machine("&mn&") . "&s2)
				End If
			Next
		End If
	End If
	' 
	Return equips.Size
End Sub

Public Sub SetDataCollection(ip As String,pin As String,alias As String,value As Object)
	Dim mp0 As Map = signals.Get(ip)
	If mp0<>Null Then
		Dim mp1 As Map = mp0.Get(pin)
		If mp1<>Null Then
			mp1.Put("value",value)
			mp1.Put("last",DateTime.Now)
		End If
	End If
End Sub

public Sub EquipCount As Int
	'Return jylab.IIF2(equips.IsInitialized,equips.Size,0)
End Sub

public Sub NodeCount As Int
	'Return jylab.IIF2(remotes.IsInitialized,remotes.Size,0)
End Sub

public Sub FlowCount As Int
	'Return jylab.IIF2(flown.IsInitialized,flown.Size,0)
End Sub

public Sub FlowName(index As String) As String
	If flown.IsInitialized Then
		'Return jylab.IIF(flown.ContainsKey(index),flown.Get(index), "查無" & index)
	Else
		Return "查無" & index
	End If
End Sub

Sub bool2int(value As Boolean) As Int
	If value Then
		Return 1
	Else
		Return 0
	End If
End Sub


public Sub saveparameter
	
End Sub